#ifndef DEREF_GREATER_H
#define DEREF_GREATER_H

/// \author Randy Ribler
/// \date Oct, 2004

// Disable warnings about stl names being too long.
#pragma warning(disable:4786)

#include <functional>
using namespace std;

// DerefGreater provides a functor that determines if the object that the
// first pointer points to is greater than the object that the second pointer
// points to.  That is, given two pointers pX and pY, it determines if
// (*pX > *pY).
template <typename Type>
class DerefGreater : public binary_function<Type*, Type*, bool>
{
   public:
      bool operator()(const Type* firstOp, const Type* secondOp) const;
};

// This function is used to determine if *firstOp < *secondOp
template <typename Type>
bool DerefGreater<Type>::operator()(const Type* firstOp, const Type* secondOp) 
   const
{
   return (*firstOp > *secondOp);
}

#endif

